plugins['speech'] = (function() {

    var speechlanguage = pluginconfig['speech']['language'][''];
    var dial_word = pluginconfig['speech']['dial_word'][''];
    var transfer_word = pluginconfig['speech']['transfer_word'][''];
    var hangup_word = pluginconfig['speech']['hangup_word'][''];
    var donotdisturb_word = pluginconfig['speech']['donotdisturb_word'][''];
    var available_word = pluginconfig['speech']['available_word'][''];
    var recognition;
    var recognizing=0;

    return { 

        loadLang: function(values) {
            var hash = hex_md5(secret+lastkey);
            queuedcommand = "<msg data=\"" + myposition + "|pluginlang|" + language + "~speech" + "|" + hash + "\" />";
            sendcommand();
        },

        setLang: function() {
            if($('#speechTitle').length > 0) {
                $('#speechTitle').html(lang['speech_input']);
                $('#speech-input-field').attr('lang',speechlanguage);
                $('#box_speechbox .langcollapse').attr('data-original-title',lang.collapse);
                $('#box_speechbox .langlockunlock').attr('data-original-title',lang.toggle_lock);
            }
        },

        embed: function() {

            var oldclient=0;
            if ($('#box_asternicTagbox').length > 0) {
                oldclient=1;
            }
 
            if($('#box_speechbox').length<=0) {
                if (oldclient==1) {
                    var klon = $( '#box_asternicTagbox' );
                    var newklon = klon.clone().attr( { id: 'box_speechbox' }).css({display: 'block'}).insertBefore( klon );
                    newklon.find('*').each(function() {
                       if(typeof $(this).attr('id') == 'undefined') {
                       } else {
                           if($(this).attr('id')=='tagcall') { $(this).attr('id','speechTitle').html(lang.speech_input); }
                           if($(this).attr('id')=='toggle-asternicTag') { $(this).attr('id','toggle-speech'); }
                           if($(this).attr('id')=='asternicTag') { $(this).attr('id','speech').css('text-align','center'); }
                       }
                    });

                } else {
                   // New bootstrap client
                   var newklon = $('<div class="grid-stack-item" id="box_speechbox" ><div class="grid-stack-item-content boxstyle boxstylebg"><div id="speechcontent" class="widgetcontent widget widget-color"><header role="heading"><div class="widget-ctrls" role="menu"><a class="myclick button-icon widget-toggle-btn langcollapse" data-toggle="tooltip" rel="tooltip" title="" data-placement="bottom" data-original-title="Collapse"><i class="fa fa-caret-square-o-up"></i></a><a class="myclick button-icon widget-lock-btn langlockunlock" data-toggle="tooltip" rel="tooltip" title="" data-placement="bottom" data-original-title="Lock/Unlock"><i class="fa fa-unlock-alt"></i></a></div><span class="handle widget-icon"><i class="fa fa-bars"></i></span><h3><span id="speechTitle">Voice Commands</span></h3></header><div class="widgetscroll" id="speechlist"><div id="speech" class="text-center" style="padding-top:5px;"></div></div></div></div></div>');
                   grid = $('.grid-stack').data('gridstack');
                   grid.add_widget(newklon,0,0,3,2,true);
                   $('#box_speechbox [data-toggle="tooltip"]').tooltip({container:'body'});
                }
            }
            if (oldclient==1) {
                makeSortable('right');
                if(typeof(mypreferences.rightColumnOrder)=='string') {
                    ordenarDiv('right_column',mypreferences.rightColumnOrder);
                }
            } else {
               window.resizinggrid=1;
               var jsongrid = Base64.decode(mypreferences.grid);
                   if(jsongrid.length>0) {
                   try {
                       var dita = JSON.parse(jsongrid);
                       for (var item in dita) {
                           if(dita[item].id=='box_speechbox') {
                               grid.update($('#'+dita[item].id),dita[item].x,dita[item].y,dita[item].width,dita[item].height);
                           }
                       }
                   } catch(e) {
                       debug("Invalid JSON in grid pref");
                   }
               }
               window.resizinggrid=0;
            }

            /*$('#speech').html("<input id='speech-input-field' speech type='text' x-webkit-speech />");*/
            $('#speech').html("<input id='speech-input-field' type='text' /><button type='button' id='speech-mic' class='speechrecoff' />");

            $("#speech-mic").on( "click", function() {
                if(recognizing==0) {
                    recognition.start();
                 } else {
                    recognition.stop();
                 }
            });

            this.loadLang();
        },

        inputChange: function(e) {
            if (e.results) { 
                for (var i = 0, result; result = e.results[i]; ++i) {
                    debug(result.utterance, result.confidence);
                }
                debug('Best result: ' + this.value);

                if(this.value.indexOf(transfer_word)>=0) {
                    var destino = stripNonNumeric(this.value);
                    debug("transfiero a "+destino);
                    dial(destino);
                }
                if(this.value.indexOf(dial_word)>=0) {
                    var destino = stripNonNumeric(this.value);
                    debug("marco a "+destino);
                    dial(destino);
                }
                if(this.value.indexOf(donotdisturb_word)>=0) {
                  setinfo("Do not Disturb");
                }
                if(this.value.indexOf(available_word)>=0) {
                  setinfo('');
                }
                if(this.value.indexOf(hangup_word)>=0) {
                   hangup(myposition);
                }
            }
        },

        init: function() {
            if($('#box_speechbox').length==0) {
                if ('webkitSpeechRecognition' in window) {
                    recognition = new webkitSpeechRecognition();
                    recognition.continuous = true;
                    recognition.interimResults = false;

                    recognition.onstart = function() { 
                        debug('speech start'); 
                        recognizing=1;
                        $('#speech-mic').addClass('speechrecon').removeClass('speechrecoff'); 
                    }
                    recognition.onresult = function(event) { 
                      for (var i = event.resultIndex; i < event.results.length; ++i) {
                         if (event.results[i].isFinal) {
                             debug('final = ' + event.results[i][0].transcript);
                             var bestmatch = event.results[i][0].transcript;
                             $('#speech-input-field').val(bestmatch);
                             if(bestmatch.indexOf(transfer_word)>=0) {
                                 var destino = stripNonNumeric(bestmatch);
                                 debug("transfer to "+destino);
                                 dial(destino);
                             }
                             if(bestmatch.indexOf(dial_word)>=0) {
                                 var destino = stripNonNumeric(bestmatch);
                                 debug("dial "+destino);
                                 dial(destino);
                             }
                             if(bestmatch.indexOf(donotdisturb_word)>=0) {
                                 setinfo("Do not Disturb");
                             }
                             if(bestmatch.indexOf(available_word)>=0) {
                                 setinfo('');
                             }
                             if(bestmatch.indexOf(hangup_word)>=0) {
                                 hangup(myposition);
                             }
                         } else {
                           debug('interim = ' + event.results[i][0].transcript);
                         }
                      } 
                    }
                    recognition.onerror = function(event) { 
                        debug('error'); 
                        $('#speech-mic').removeClass('speechrecon').addClass('speechrecoff'); 
                        recognizing=0;
                    }
                    recognition.onend = function() { 
                        debug('speech end'); 
                        $('#speech-mic').removeClass('speechrecon').addClass('speechrecoff'); 
                        recognizing=0;
                    }
                    recognition.lang = speechlanguage;
                    recognition.start();

                    this.embed();

                    //var input = document.querySelector('[x-webkit-speech]');
                    //input.addEventListener('change', this.inputChange, false);
                    //input.addEventListener('webkitspeechchange', this.inputChange, false);
                }
            }
        }
    }
}());
